Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class JWindow

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--java.awt.Window
                        |
                        +--javax.swing.JWindow

public class JWindow
extends java.awt.Window
implements Accessible, RootPaneContainer

A JWindow is a container that can be displayed anywhere on the user's desktop. It does not have the title bar, window-management buttons, or other trimmings associated with a JFrame, but it is still a "first-class citizen" of the user's desktop, and can exist anywhere on it.

The JWindow component contains a JRootPane as it's only child. The contentPane() should be the parent of any children of the JWindow. From the older java.awt.Window object you would normally do something like this:

           window.add(child);

However, using JWindow you would code:

           window.getContentPane().add(child);

The same is true of setting LayoutManagers, removing components, listing children, etc. All these methods should normally be sent to the contentPane() instead of the JWindow itself. The contentPane() will always be non-null. Attempting to set it to null will cause the JWindow to throw an exception. The default contentPane() will have a BorderLayout manager set on it.

Please see the JRootPane documentation for a complete description of the contentPane(), glassPane(), and layeredPane() components.

For the keyboard keys used by this component in the standard Look and Feel (L&F) renditions, see the JWindow key assignments.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `JRootPane`, Serialized Form

Inner Class Summary
`protected class` | `JWindow.AccessibleJWindow` The class used to obtain the AccessibleRole for this object.

Field Summary
`protected AccessibleContext` | `accessibleContext` The accessible context property
`protected JRootPane` | `rootPane` The JRootPane instance that manages the `contentPane` and optional `menuBar` for this frame, as well as the `glassPane`.
`protected boolean` | `rootPaneCheckingEnabled` If true then calls to `add` and `setLayout` cause an exception to be thrown.

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Constructor Summary
`JWindow()` Creates a window with no specified owner.
`JWindow(java.awt.Frame owner)` Creates a window with the specified owner frame.

Method Summary
`protected void` | `addImpl(java.awt.Component comp, java.lang.Object constraints, int index)` By default, children may not be added directly to a this component, they must be added to its contentPane instead.
`protected JRootPane` | `createRootPane()` Called by the constructor methods to create the default rootPane.
`AccessibleContext` | `getAccessibleContext()` Get the AccessibleContext associated with this JWindow
`java.awt.Container` | `getContentPane()` Returns the contentPane object for this window.
`java.awt.Component` | `getGlassPane()` Returns the glassPane object for this window.
`JLayeredPane` | `getLayeredPane()` Returns the layeredPane object for this window.
`JRootPane` | `getRootPane()` Returns the rootPane object for this window.
`protected boolean` | `isRootPaneCheckingEnabled()` Returns whether calls to `add` and `setLayout` cause an exception to be thrown.
`protected java.lang.String` | `paramString()` Returns a string representation of this JWindow.
`void` | `setContentPane(java.awt.Container contentPane)` Sets the contentPane property.
`void` | `setGlassPane(java.awt.Component glassPane)` Sets the glassPane property.
`void` | `setLayeredPane(JLayeredPane layeredPane)` Sets the layeredPane property.
`void` | `setLayout(java.awt.LayoutManager manager)` By default the layout of this component may not be set, the layout of its contentPane should be set instead.
`protected void` | `setRootPane(JRootPane root)` Sets the rootPane property.
`protected void` | `setRootPaneCheckingEnabled(boolean enabled)` Determines whether calls to `add` and `setLayout` cause an exception to be thrown.
`protected void` | `windowInit()` Called by the constructors to init the JWindow properly.

Methods inherited from class java.awt.Window
`addNotify, addWindowListener, dispose, getFocusOwner, getLocale, getToolkit, getWarningString, isShowing, pack, postEvent, processEvent, processWindowEvent, removeWindowListener, show, toBack, toFront`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, countComponents, deliverEvent, doLayout, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getInsets, getLayout, getMaximumSize, getMinimumSize, getPreferredSize, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paint, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, remove, removeAll, removeContainerListener, removeNotify, update, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, contains, createImage, createImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, getBackground, getBounds, getColorModel, getCursor, getFont, getFontMetrics, getForeground, getGraphics, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getTreeLock, gotFocus, handleEvent, hide, imageUpdate, inside, isEnabled, isFocusTraversable, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, remove, removeComponentListener, removeFocusListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, repaint, requestFocus, reshape, resize, resize, setBackground, setBounds, setBounds, setCursor, setEnabled, setFont, setForeground, setLocale, setLocation, setLocation, setName, setSize, setSize, setVisible, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### rootPane

    protected JRootPane rootPane

  The JRootPane instance that manages the `contentPane` and optional `menuBar` for this frame, as well as the `glassPane`.
  See Also:
    `getRootPane()`, `setRootPane(javax.swing.JRootPane)`

### rootPaneCheckingEnabled

    protected boolean rootPaneCheckingEnabled

  If true then calls to `add` and `setLayout` cause an exception to be thrown.
  See Also:
    `isRootPaneCheckingEnabled()`, `setRootPaneCheckingEnabled(boolean)`

### accessibleContext

    protected AccessibleContext accessibleContext

  The accessible context property

Constructor Detail

### JWindow

    public JWindow()

  Creates a window with no specified owner.

### JWindow

    public JWindow(java.awt.Frame owner)

  Creates a window with the specified owner frame.
  Parameters:
    `owner` - the frame from which the window is displayed

Method Detail

### windowInit

    protected void windowInit()

  Called by the constructors to init the JWindow properly.

### createRootPane

    protected JRootPane createRootPane()

  Called by the constructor methods to create the default rootPane.

### isRootPaneCheckingEnabled

    protected boolean isRootPaneCheckingEnabled()

  Returns whether calls to `add` and `setLayout` cause an exception to be thrown.
  Returns:
    true if `add` and `setLayout` are checked
  See Also:
    `addImpl(java.awt.Component, java.lang.Object, int)`, `setLayout(java.awt.LayoutManager)`, `setRootPaneCheckingEnabled(boolean)`

### setRootPaneCheckingEnabled

    protected void setRootPaneCheckingEnabled(boolean enabled)

  Determines whether calls to `add` and `setLayout` cause an exception to be thrown.
  Parameters:
    `enabled` - a boolean value, true if checking is to be enabled, which cause the exceptions to be thrown
  See Also:
    `addImpl(java.awt.Component, java.lang.Object, int)`, `setLayout(java.awt.LayoutManager)`, `isRootPaneCheckingEnabled()`

### addImpl

    protected void addImpl(java.awt.Component comp,
                           java.lang.Object constraints,
                           int index)

  By default, children may not be added directly to a this component, they must be added to its contentPane instead. For example:

       thisComponent.getContentPane().add(child)

  An attempt to add to directly to this component will cause an runtime exception to be thrown. Subclasses can disable this behavior.
  Throws:
    Error - if called with rootPaneChecking true
  Overrides:
    addImpl in class java.awt.Container
  See Also:
    `setRootPaneCheckingEnabled(boolean)`

### setLayout

    public void setLayout(java.awt.LayoutManager manager)

  By default the layout of this component may not be set, the layout of its contentPane should be set instead. For example:

       thisComponent.getContentPane().setLayout(new BorderLayout())

  An attempt to set the layout of this component will cause an runtime exception to be thrown. Subclasses can disable this behavior.
  Throws:
    Error - if called with rootPaneChecking true
  Overrides:
    setLayout in class java.awt.Container
  See Also:
    `setRootPaneCheckingEnabled(boolean)`

### getRootPane

    public JRootPane getRootPane()

  Returns the rootPane object for this window.
  Specified by:
    getRootPane in interface RootPaneContainer
  See Also:
    `setRootPane(javax.swing.JRootPane)`, `RootPaneContainer.getRootPane()`

### setRootPane

    protected void setRootPane(JRootPane root)

  Sets the rootPane property. This method is called by the constructor.
  Parameters:
    `root` - the rootPane object for this window
  See Also:
    `getRootPane()`

### getContentPane

    public java.awt.Container getContentPane()

  Returns the contentPane object for this window.
  Specified by:
    getContentPane in interface RootPaneContainer
  Returns:
    the Container which is the contentPane
  See Also:
    `setContentPane(java.awt.Container)`, `RootPaneContainer.getContentPane()`

### setContentPane

    public void setContentPane(java.awt.Container contentPane)

  Sets the contentPane property. This method is called by the constructor.
  Specified by:
    setContentPane in interface RootPaneContainer
  Parameters:
    `contentPane` - the contentPane object for this window
  Throws:
    java.awt.IllegalComponentStateException - (a runtime exception) if the content pane parameter is null
  See Also:
    `getContentPane()`, `RootPaneContainer.setContentPane(java.awt.Container)`

### getLayeredPane

    public JLayeredPane getLayeredPane()

  Returns the layeredPane object for this window.
  Specified by:
    getLayeredPane in interface RootPaneContainer
  Returns:
    the JLayeredPane object
  See Also:
    `setLayeredPane(javax.swing.JLayeredPane)`, `RootPaneContainer.getLayeredPane()`

### setLayeredPane

    public void setLayeredPane(JLayeredPane layeredPane)

  Sets the layeredPane property. This method is called by the constructor.
  Specified by:
    setLayeredPane in interface RootPaneContainer
  Parameters:
    `layeredPane` - the layeredPane object for this window
  Throws:
    java.awt.IllegalComponentStateException - (a runtime exception) if the content pane parameter is null
  See Also:
    `getLayeredPane()`, `RootPaneContainer.setLayeredPane(javax.swing.JLayeredPane)`

### getGlassPane

    public java.awt.Component getGlassPane()

  Returns the glassPane object for this window.
  Specified by:
    getGlassPane in interface RootPaneContainer
  Returns:
    the Component which is the glassPane
  See Also:
    `setGlassPane(java.awt.Component)`, `RootPaneContainer.getGlassPane()`

### setGlassPane

    public void setGlassPane(java.awt.Component glassPane)

  Sets the glassPane property. This method is called by the constructor.
  Specified by:
    setGlassPane in interface RootPaneContainer
  Parameters:
    `glassPane` - the glassPane object for this window
  See Also:
    `getGlassPane()`, `RootPaneContainer.setGlassPane(java.awt.Component)`

### paramString

    protected java.lang.String paramString()

  Returns a string representation of this JWindow. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

  Overriding paramString() to provide information about the specific new aspects of the JFC components.

  Returns:
    a string representation of this JWindow.
  Overrides:
    paramString in class java.awt.Container

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Get the AccessibleContext associated with this JWindow
  Specified by:
    getAccessibleContext in interface Accessible
  Returns:
    the AccessibleContext of this JWindow

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.